Package: argparse
Type: Package
Title: Command Line Optional and Positional Argument Parser
Version: 2.3.1
Authors@R: c(person("Trevor L.", "Davis", role=c("aut", "cre"),
             email="trevor.l.davis@gmail.com",
             comment = c(ORCID = "0000-0001-6341-4639")),
    person("Allen", "Day", role="ctb", comment="Some documentation and examples ported from the getopt package."),
    person("Python Software Foundation", role="ctb", comment="Some documentation from the argparse Python module."),
    person("Paul", "Newell", role="ctb"))
Description: A command line parser to
    be used with 'Rscript' to write "#!" shebang scripts that gracefully
    accept positional and optional arguments and automatically generate usage.
License: GPL (>= 2)
Copyright: See file (inst/)COPYRIGHTS.
URL: https://github.com/trevorld/r-argparse,
        https://trevorldavis.com/R/argparse/
BugReports: https://github.com/trevorld/r-argparse/issues
LazyLoad: yes
Depends: R (>= 3.6.0)
Imports: findpython, jsonlite, R6
SystemRequirements: python (>= 3.2)
Suggests: knitr (>= 1.15.19), rmarkdown, testthat
VignetteBuilder: knitr
RoxygenNote: 7.3.3
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2025-10-08 20:05:05 UTC; trevor
Author: Trevor L. Davis [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6341-4639>),
  Allen Day [ctb] (Some documentation and examples ported from the getopt
    package.),
  Python Software Foundation [ctb] (Some documentation from the argparse
    Python module.),
  Paul Newell [ctb]
Maintainer: Trevor L. Davis <trevor.l.davis@gmail.com>
Repository: CRAN
Date/Publication: 2025-10-08 21:20:02 UTC

# argparse: Command line optional and positional argument parser

[![CRAN Status Badge](https://www.r-pkg.org/badges/version/argparse)](https://cran.r-project.org/package=argparse)

[![R-CMD-check](https://github.com/trevorld/r-argparse/workflows/R-CMD-check/badge.svg)](https://github.com/trevorld/r-argparse/actions)

[![Coverage Status](https://img.shields.io/codecov/c/github/trevorld/r-argparse.svg)](https://codecov.io/github/trevorld/r-argparse?branch=master)

[![RStudio CRAN mirror downloads](https://cranlogs.r-pkg.org/badges/argparse)](https://cran.r-project.org/package=argparse)

<img src="man/figures/logo.png" align="right" width="200px" alt="argparse hex sticker">

`argparse` is an R package which provides a command line parser to be
used with Rscript to write "#!" shebang scripts that gracefully accept
positional and optional arguments and automatically generate usage.

To install the latest version released on CRAN use the following
command:

    > install.packages("argparse")

To install the development version use the following command:

    > remotes::install_github("trevorld/r-argparse")

## dependencies

The package has a Python dependency. It is easily satisfied if you have
Python (version 3.2 or higher) on your PATH. Read the INSTALL file for
more information if this doesn't describe you.

Additionally this package depends on the R packages `R6`, `findpython`,
and `jsonlite`.

To run the unit tests you will need the suggested R package `testthat`
and in order to build the vignette you will need the suggested R package
`knitr` which in turn probably requires the system tool `pandoc`:

    sudo apt install pandoc

## examples

    > library("argparse")
    > parser <- ArgumentParser(description='Process some integers')
    > parser$add_argument('integers', metavar='N', type="integer", nargs='+',
    +                    help='an integer for the accumulator')
    > parser$add_argument('--sum', dest='accumulate', action='store_const',
    +                    const='sum', default='max',
    +                    help='sum the integers (default: find the max)')
    > parser$print_help()
    usage: PROGRAM [-h] [--sum] N [N ...]

    Process some integers

    positional arguments:
      N           an integer for the accumulator

    optional arguments:
      -h, --help  show this help message and exit
      --sum       sum the integers (default: find the max)

Default args for `ArgumentParser()$parse_args` are `commandArgs(TRUE)`
which is what you'd want for an Rscript but not for interactive use:

    > args <- parser$parse_args(c("--sum", "1", "2", "3")) 
    > accumulate_fn <- get(args$accumulate)
    > print(accumulate_fn(args$integers))
    [1] 6

Beginning with version 2.0 `argparse` also supports argument groups:

    > parser = ArgumentParser(prog='PROG', add_help=FALSE)
    > group1 = parser$add_argument_group('group1', 'group1 description')
    > group1$add_argument('foo', help='foo help')
    > group2 = parser$add_argument_group('group2', 'group2 description')
    > group2$add_argument('--bar', help='bar help')
    > parser$print_help()
    usage: PROG [-h] [--bar BAR] foo

    optional arguments:
      -h, --help  show this help message and exit

    group1:
      group1 description

      foo         foo help

    group2:
      group2 description

      --bar BAR   bar help

as well as mutually exclusive groups:

    > parser = ArgumentParser(prog='PROG')
    > group = parser$add_mutually_exclusive_group()
    > group$add_argument('--foo', action='store_true')
    > group$add_argument('--bar', action='store_false')
    > parser$parse_args('--foo')
    $bar
    [1] TRUE

    $foo
    [1] TRUE

    > parser$parse_args('--bar')
    $bar
    [1] FALSE

    $foo
    [1] FALSE
    > parser$parse_args(c('--foo', '--bar'))
    Error in "argparse::parse_args_output(output)" : parse error:
    usage: PROG [-h] [--foo | --bar]
    PROG: error: argument --bar: not allowed with argument --foo

and even basic support for sub-commands!:

    > # create the top-level parser
    > parser = ArgumentParser(prog='PROG')
    > parser$add_argument('--foo', action='store_true', help='foo help')
    > subparsers = parser$add_subparsers(help='sub-command help')

    > # create the parser for the "a" command
    > parser_a = subparsers$add_parser('a', help='a help')
    > parser_a$add_argument('bar', type='integer', help='bar help')

    > # create the parser for the "b" command
    > parser_b = subparsers$add_parser('b', help='b help')
    > parser_b$add_argument('--baz', choices='XYZ', help='baz help')

    > # parse some argument lists
    > parser$parse_args(c('a', '12'))
    $bar
    [1] 12

    $foo
    [1] FALSE

    > parser$parse_args(c('--foo', 'b', '--baz', 'Z'))
    $baz
    [1] "Z"

    $foo
    [1] TRUE

    > parser$print_help()
    usage: PROG [-h] [--foo] {a,b} ...

    positional arguments:
      {a,b}       sub-command help
        a         a help
        b         b help

    optional arguments:
      -h, --help  show this help message and exit
      --foo       foo help

    > parser_a$print_help()
    usage: PROG a [-h] bar

    positional arguments:
      bar         bar help

    optional arguments:
      -h, --help  show this help message and exit

    > parser_b$print_help()
    usage: PROG b [-h] [--baz {X,Y,Z}]

    optional arguments:
      -h, --help     show this help message and exit
      --baz {X,Y,Z}  baz help

# argparse: Command line optional and positional argument parser <img src="man/figures/logo.png" align="right" width="200px" alt="argparse hex sticker">

[![CRAN Status Badge](https://www.r-pkg.org/badges/version/argparse)](https://cran.r-project.org/package=argparse)
[![R-CMD-check](https://github.com/trevorld/r-argparse/actions/workflows/R-CMD-check.yaml/badge.svg?branch=master)](https://github.com/trevorld/r-argparse/actions)
[![Coverage Status](https://codecov.io/github/trevorld/r-argparse/branch/master/graph/badge.svg)](https://app.codecov.io/github/trevorld/r-argparse?branch=master)
[![RStudio CRAN mirror downloads](https://cranlogs.r-pkg.org/badges/argparse)](https://cran.r-project.org/package=argparse)

`argparse` is an R package which provides a command line parser to be
used with Rscript to write "#!" shebang scripts that gracefully accept
positional and optional arguments and automatically generate usage.

To install the latest version released on CRAN use the following
command:

    > install.packages("argparse")

To install the development version use the following command:

    > remotes::install_github("trevorld/r-argparse")

## dependencies

The package has a Python dependency. It is easily satisfied if you have
Python (version 3.2 or higher) on your PATH. Read the INSTALL file for
more information if this doesn't describe you.

Additionally this package depends on the R packages `R6`, `findpython`,
and `jsonlite`.

To run the unit tests you will need the suggested R package `testthat`
and in order to build the vignette you will need the suggested R package
`knitr` which in turn probably requires the system tool `pandoc`:

    sudo apt install pandoc

## examples

    > library("argparse")
    > parser <- ArgumentParser(description='Process some integers')
    > parser$add_argument('integers', metavar='N', type="integer", nargs='+',
    +                    help='an integer for the accumulator')
    > parser$add_argument('--sum', dest='accumulate', action='store_const',
    +                    const='sum', default='max',
    +                    help='sum the integers (default: find the max)')
    > parser$print_help()
    usage: PROGRAM [-h] [--sum] N [N ...]

    Process some integers

    positional arguments:
      N           an integer for the accumulator

    optional arguments:
      -h, --help  show this help message and exit
      --sum       sum the integers (default: find the max)

Default args for `ArgumentParser()$parse_args` are `commandArgs(TRUE)`
which is what you'd want for an Rscript but not for interactive use:

    > args <- parser$parse_args(c("--sum", "1", "2", "3")) 
    > accumulate_fn <- get(args$accumulate)
    > print(accumulate_fn(args$integers))
    [1] 6

Beginning with version 2.0 `argparse` also supports argument groups:

    > parser = ArgumentParser(prog='PROG', add_help=FALSE)
    > group1 = parser$add_argument_group('group1', 'group1 description')
    > group1$add_argument('foo', help='foo help')
    > group2 = parser$add_argument_group('group2', 'group2 description')
    > group2$add_argument('--bar', help='bar help')
    > parser$print_help()
    usage: PROG [-h] [--bar BAR] foo

    optional arguments:
      -h, --help  show this help message and exit

    group1:
      group1 description

      foo         foo help

    group2:
      group2 description

      --bar BAR   bar help

as well as mutually exclusive groups:

    > parser = ArgumentParser(prog='PROG')
    > group = parser$add_mutually_exclusive_group()
    > group$add_argument('--foo', action='store_true')
    > group$add_argument('--bar', action='store_false')
    > parser$parse_args('--foo')
    $bar
    [1] TRUE

    $foo
    [1] TRUE

    > parser$parse_args('--bar')
    $bar
    [1] FALSE

    $foo
    [1] FALSE
    > parser$parse_args(c('--foo', '--bar'))
    Error in "argparse::parse_args_output(output)" : parse error:
    usage: PROG [-h] [--foo | --bar]
    PROG: error: argument --bar: not allowed with argument --foo

and even basic support for sub-commands!:

    > # create the top-level parser
    > parser = ArgumentParser(prog='PROG')
    > parser$add_argument('--foo', action='store_true', help='foo help')
    > subparsers = parser$add_subparsers(help='sub-command help')

    > # create the parser for the "a" command
    > parser_a = subparsers$add_parser('a', help='a help')
    > parser_a$add_argument('bar', type='integer', help='bar help')

    > # create the parser for the "b" command
    > parser_b = subparsers$add_parser('b', help='b help')
    > parser_b$add_argument('--baz', choices='XYZ', help='baz help')

    > # parse some argument lists
    > parser$parse_args(c('a', '12'))
    $bar
    [1] 12

    $foo
    [1] FALSE

    > parser$parse_args(c('--foo', 'b', '--baz', 'Z'))
    $baz
    [1] "Z"

    $foo
    [1] TRUE

    > parser$print_help()
    usage: PROG [-h] [--foo] {a,b} ...

    positional arguments:
      {a,b}       sub-command help
        a         a help
        b         b help

    optional arguments:
      -h, --help  show this help message and exit
      --foo       foo help

    > parser_a$print_help()
    usage: PROG a [-h] bar

    positional arguments:
      bar         bar help

    optional arguments:
      -h, --help  show this help message and exit

    > parser_b$print_help()
    usage: PROG b [-h] [--baz {X,Y,Z}]

    optional arguments:
      -h, --help     show this help message and exit
      --baz {X,Y,Z}  baz help

#!/usr/bin/env Rscript
# Copyright 2012-2013 Trevor L Davis <trevor.l.davis@gmail.com>
# Copyright 2008 Allen Day
#
#  This file is free software: you may copy, redistribute and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation, either version 2 of the License, or (at your
#  option) any later version.
#
#  This file is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
suppressPackageStartupMessages(library("argparse"))

# create parser object
parser <- ArgumentParser()

# specify our desired options
# by default ArgumentParser will add an help option
parser$add_argument(
	"-v",
	"--verbose",
	action = "store_true",
	default = TRUE,
	help = "Print extra output [default]"
)
parser$add_argument(
	"-q",
	"--quietly",
	action = "store_false",
	dest = "verbose",
	help = "Print little output"
)
parser$add_argument(
	"-c",
	"--count",
	type = "integer",
	default = 5,
	help = "Number of random normals to generate [default %(default)s]",
	metavar = "number"
)
parser$add_argument(
	"--generator",
	default = "rnorm",
	help = "Function to generate random deviates [default \"%(default)s\"]"
)
parser$add_argument(
	"--mean",
	default = 0,
	type = "double",
	help = "Mean if generator == \"rnorm\" [default %(default)s]"
)
parser$add_argument(
	"--sd",
	default = 1,
	type = "double",
	metavar = "standard deviation",
	help = "Standard deviation if generator == \"rnorm\" [default %(default)s]"
)

# get command line options, if help option encountered print help and exit,
# otherwise if options not found on command line then set defaults,
args <- parser$parse_args()

# print some progress messages to stderr if "quietly" wasn't requested
if (args$verbose) {
	write("writing some verbose output to standard error...\n", stderr())
}

# do some operations based on user input
if (args$generator == "rnorm") {
	cat(paste(rnorm(args$count, mean = args$mean, sd = args$sd), collapse = "\n"))
} else {
	cat(paste(do.call(args$generator, list(args$count)), collapse = "\n"))
}
cat("\n")

#!/usr/bin/env Rscript
# Copyright 2012-2013 Trevor L Davis <trevor.l.davis@gmail.com>
#
#  This file is free software: you may copy, redistribute and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation, either version 2 of the License, or (at your
#  option) any later version.
#
#  This file is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
suppressPackageStartupMessages(library("argparse"))

parser <- ArgumentParser()
parser$add_argument(
	"-n",
	"--add_numbers",
	action = "store_true",
	default = FALSE,
	help = "Print line number at the beginning of each line [default]"
)
parser$add_argument("file", nargs = 1, help = "File to be displayed")

args <- parser$parse_args()

file <- args$file

if (file.access(file) == -1) {
	stop(sprintf("Specified file ( %s ) does not exist", file))
} else {
	file_text <- readLines(file)
}

if (args$add_numbers) {
	cat(paste(seq_along(file_text), file_text), sep = "\n")
} else {
	cat(file_text, sep = "\n")
}

# Copyright (c) 2012-2024 Trevor L. Davis <trevor.l.davis@gmail.com>
#
#  This file is free software: you may copy, redistribute and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation, either version 2 of the License, or (at your
#  option) any later version.
#
#  This file is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This file incorporates work from the argparse module in Python 2.7.3.
#
#     Copyright (c) 2001-2012 Python Software Foundation; All Rights Reserved
#
# See (inst/)COPYRIGHTS or http://docs.python.org/2/license.html for the full
# Python (GPL-compatible) license stack.

#' Create a command line parser
#'
#' `ArgumentParser()` creates a parser object that acts as
#' a wrapper to Python's `argparse` module
#'
#' @param ... Arguments cleaned and passed to Pythons `argparse.ArgumentParser()`
#' @param python_cmd Python executable for `argparse` to use.
#'      Must have `argparse` and `json` modules (automatically bundled with Python 2.7 and 3.2+).
#'      If you need Unicode argument support then you must use Python 3.0+.
#'      Default will be to use `findpython` package to find suitable Python binary.
#' @return  `ArgumentParser()` returns a parser object which contains
#'    an `add_argument()` function to add arguments to the parser,
#'    a `parse_args()` function to parse command line arguments into
#'    a list, a `print_help()` and a `print_usage()` function to print
#'    usage information.  See code examples, package vignette,
#'    and corresponding python module for more information on how to use it.
#'
#' @references Python's `argparse` library, which this package is based on,
#'  is described here: \url{https://docs.python.org/3/library/argparse.html}
#'
#' @examples
#'
#' if (argparse:::detects_python()) {
#'   parser <- ArgumentParser(description='Process some integers')
#'   parser$add_argument('integers', metavar='N', type = "integer", nargs='+',
#'                      help='an integer for the accumulator')
#'   parser$add_argument('--sum', dest='accumulate', action='store_const',
#'                      const='sum', default='max',
#'                      help='sum the integers (default: find the max)')
#'   parser$print_help()
#'   # default args for ArgumentParser()$parse_args are commandArgs(TRUE)
#'   # which is what you'd want for an Rscript but not for interactive use
#'   args <- parser$parse_args(c("--sum", "1", "2", "3"))
#'   accumulate_fn <- get(args$accumulate)
#'   print(accumulate_fn(args$integers))
#' }
#' @importFrom R6 R6Class
#' @export
ArgumentParser <- function(..., python_cmd = NULL) {
	python_cmd <- find_python_cmd(python_cmd)
	assert_python_cmd(python_cmd)
	initial_python_code <- c(
		"import argparse",
		"try:",
		"    import json",
		"except ImportError:",
		"    import simplejson as json",
		"",
		"def logical(s):",
		"    if isinstance(s, bool):",
		"        return s",
		"    elif s in ('T', 'TRUE', 'True', 'true'):",
		"        return True",
		"    elif s in ('F', 'FALSE', 'False', 'false'):",
		"        return False",
		"    else:",
		"        raise ValueError(\"could not convert string to logical: '{}'\".format(s))",
		"",
		sprintf(
			"parser = argparse.ArgumentParser(%s)",
			convert_..._to_arguments("ArgumentParser", ...)
		),
		""
	)
	Parser$new(Code$new(python_cmd, initial_python_code), "parser")
}

Code <- R6Class(
	"Code",
	public = list(
		append = function(new_code) {
			private$code <- c(private$code, new_code)
		},
		run = function(new_code) {
			code <- c(private$code, new_code)
			suppressWarnings(system2(private$cmd, input = code, stdout = TRUE, stderr = TRUE))
		},
		initialize = function(cmd, code = character(0)) {
			private$cmd <- cmd
			private$code <- code
		}
	),
	private = list(code = NULL, cmd = NULL)
)

Group <- R6Class(
	"Group",
	public = list(
		initialize = function(python_code, name) {
			private$python_code <- python_code
			private$name <- name
		},
		add_argument = function(...) {
			private$python_code$append(sprintf(
				"%s.add_argument(%s)",
				private$name,
				convert_..._to_arguments("add_argument", ...)
			))
			invisible(NULL)
		}
	),
	private = list(python_code = NULL, name = NULL)
)

# Can call `add_mutually_exclusive_group()` from an "argument group"
# but not from a "mutually exclusive group" (since Python v3.14)
ArgumentGroup <- R6Class(
	"ArgumentGroup",
	inherit = Group,
	public = list(
		add_mutually_exclusive_group = function(required = FALSE) {
			group_name <- paste0(
				private$name,
				"_mutually_exclusive_group",
				private$n_mutually_exclusive_groups
			)
			private$n_mutually_exclusive_groups <- private$n_mutually_exclusive_groups + 1L
			private$python_code$append(sprintf(
				"%s = %s.add_mutually_exclusive_group(%s)",
				group_name,
				private$name,
				ifelse(required, "required=True", "")
			))
			Group$new(private$python_code, group_name)
		}
	),
	private = list(
		python_code = NULL,
		name = NULL,
		n_mutually_exclusive_groups = 0L
	)
)

Subparsers <- R6Class(
	"Subparsers",
	public = list(
		initialize = function(python_code, name) {
			private$python_code <- python_code
			private$name <- name
		},
		add_parser = function(...) {
			parser_name <- paste0(private$name, "_subparser", private$n_subparsers)
			private$n_subparsers <- private$n_subparsers + 1L
			private$python_code$append(sprintf(
				"%s = %s.add_parser(%s)",
				parser_name,
				private$name,
				convert_..._to_arguments("ArgumentParser", ...)
			))
			Parser$new(private$python_code, parser_name)
		}
	),
	private = list(python_code = NULL, name = NULL, n_subparsers = 0L)
)

Parser <- R6Class(
	"Parser",
	public = list(
		parse_args = function(args = commandArgs(TRUE)) {
			new_code <- c(
				sprintf(
					"args = %s.parse_args([%s])",
					private$name,
					paste(sprintf("'%s'", args), collapse = ", ")
				),
				"print(json.dumps(args.__dict__, sort_keys=True))"
			)
			output <- private$python_code$run(new_code)
			parse_args_output(output)
		},
		parse_intermixed_args = function(args = commandArgs(TRUE)) {
			new_code <- c(
				sprintf(
					"args = %s.parse_intermixed_args([%s])",
					private$name,
					paste(sprintf("'%s'", args), collapse = ", ")
				),
				"print(json.dumps(args.__dict__, sort_keys=True))"
			)
			output <- private$python_code$run(new_code)
			parse_args_output(output)
		},
		parse_known_args = function(args = commandArgs(TRUE)) {
			new_code <- c(
				sprintf(
					"args_remainder = %s.parse_known_args([%s])",
					private$name,
					paste(sprintf("'%s'", args), collapse = ", ")
				),
				"print(json.dumps((args_remainder[0].__dict__, args_remainder[1])))"
			)
			output <- private$python_code$run(new_code)
			parse_args_output(output)
		},
		parse_known_intermixed_args = function(args = commandArgs(TRUE)) {
			new_code <- c(
				sprintf(
					"args_remainder = %s.parse_known_intermixed_args([%s])",
					private$name,
					paste(sprintf("'%s'", args), collapse = ", ")
				),
				"print(json.dumps((args_remainder[0].__dict__, args_remainder[1])))"
			)
			output <- private$python_code$run(new_code)
			parse_args_output(output)
		},
		format_help = function() {
			paste(
				private$python_code$run(sprintf("%s.print_help()", private$name)),
				collapse = "\n"
			)
		},
		format_usage = function() {
			paste(
				private$python_code$run(sprintf("%s.print_usage()", private$name)),
				collapse = "\n"
			)
		},
		print_help = function() {
			cat(private$python_code$run(sprintf("%s.print_help()", private$name)), sep = "\n")
			invisible(NULL)
		},
		print_usage = function() {
			cat(private$python_code$run(sprintf("%s.print_usage()", private$name)), sep = "\n")
			invisible(NULL)
		},
		get_default = function(...) {
			stop("We don't currently support `get_default()`")
		},
		set_defaults = function(...) {
			private$python_code$append(sprintf(
				"%s.set_defaults(%s)",
				private$name,
				convert_..._to_arguments("add_argument", ...)
			))
			invisible(NULL)
		},
		add_argument = function(...) {
			private$python_code$append(sprintf(
				"%s.add_argument(%s)",
				private$name,
				convert_..._to_arguments("add_argument", ...)
			))
			invisible(NULL)
		},
		add_argument_group = function(...) {
			group_name <- paste0(private$name, "_group", private$n_groups)
			private$n_groups <- private$n_groups + 1L
			private$python_code$append(sprintf(
				"%s = %s.add_argument_group(%s)",
				group_name,
				private$name,
				convert_..._to_arguments("add_argument", ...)
			))
			ArgumentGroup$new(private$python_code, group_name)
		},
		add_mutually_exclusive_group = function(required = FALSE) {
			group_name <- paste0(
				private$name,
				"_mutually_exclusive_group",
				private$n_mutually_exclusive_groups
			)
			private$n_mutually_exclusive_groups <- private$n_mutually_exclusive_groups + 1L
			private$python_code$append(sprintf(
				"%s = %s.add_mutually_exclusive_group(%s)",
				group_name,
				private$name,
				ifelse(required, "required=True", "")
			))
			Group$new(private$python_code, group_name)
		},
		add_subparsers = function(...) {
			subparsers_name <- paste0(private$name, "_subparsers")
			private$python_code$append(sprintf(
				"%s = %s.add_subparsers(%s)",
				subparsers_name,
				private$name,
				convert_..._to_arguments("add_argument", ...)
			))
			Subparsers$new(private$python_code, subparsers_name)
		},
		initialize = function(python_code, name) {
			private$python_code <- python_code
			private$name <- name
		}
	),
	private = list(python_code = NULL, name = NULL, n_mutually_exclusive_groups = 0L, n_groups = 0L)
)

parse_args_output <- function(output) {
	if (grepl("^usage:", output[1])) {
		has_positional_arguments <- any(grepl("^positional arguments:", output))
		has_optional_arguments <- any(grepl("^optional arguments:|^options:", output))
		if (has_positional_arguments || has_optional_arguments) {
			print_message_and_exit(output, "help requested:")
		} else {
			pa_stop(output, "parse error:")
		}
	} else if (grepl("^Traceback", output[1])) {
		pa_stop(output, "python error:")
	} else if (any(grepl("^SyntaxError: Non-ASCII character", output))) {
		message <- paste(
			"Non-ASCII character detected.",
			"If you wish to use Unicode arguments/options",
			"please upgrade to Python 3.2+",
			"Please see file INSTALL for more details."
		)
		pa_stop(message, "non-ascii character error:")
	} else if (
		any(grepl("^SyntaxError: positional argument follows keyword argument", output)) ||
			grepl("^SyntaxError: non-keyword arg after keyword arg", output[2])
	) {
		message <- "Positional argument following keyword argument."
		pa_stop(message, "syntax error:")
	} else if (grepl("^\\{|^\\[", output)) {
		jsonlite::fromJSON(paste(output, collapse = ""))
	} else {
		# presumably version number request
		print_message_and_exit(output, "version requested:")
	}
}

# @param argument argument to be converted from R to Python
convert_argument <- function(argument, as_list = FALSE) {
	if (is.character(argument)) {
		argument <- convert_character(argument)
	}
	if (is.numeric(argument)) {
		argument <- as.character(argument)
	}
	if (is.logical(argument)) {
		argument <- ifelse(argument, "True", "False")
	}
	if (is.null(argument)) {
		argument <- "None"
	}
	if (as_list) {
		argument <- sprintf("[%s]", paste(argument, collapse = ", "))
	} else if (length(argument) > 1) {
		argument <- sprintf("(%s)", paste(argument, collapse = ", "))
	}
	argument
}

convert_character <- function(s) {
	bool <- substr(s, nchar(s), nchar(s)) == '"'
	ifelse(bool, paste0("r'''", s, "'''"), paste0('r"""', s, '"""'))
}

get_python_type <- function(type, proposed_arguments) {
	python_type <- switch(
		type,
		character = "str",
		double = "float",
		integer = "int",
		logical = "logical",
		numeric = "float",
		stop(paste(
			sprintf("type %s not supported,", type),
			"supported types:",
			"'logical', 'integer', 'double' or 'character'"
		))
	)
	sprintf("type=%s", python_type)
}

should_as_list <- function(name, argument_list) {
	if (
		name == "default" &&
			(argument_list[["action"]] %||% "store") == "append"
	) {
		TRUE
	} else {
		FALSE
	}
}

`%||%` <- function(x, y) if (is.null(x)) y else x # nolint

# @param mode Either "add_argument" or "ArgumentParser"
convert_..._to_arguments <- function(mode, ...) {
	argument_list <- list(...)
	argument_names <- names(argument_list)
	if (is.null(argument_names)) {
		argument_names <- rep_len("", length(argument_list))
	}
	equals <- ifelse(argument_names == "", "", "=")
	proposed_arguments <- c()
	for (ii in seq_along(argument_list)) {
		name <- argument_names[ii]
		equal <- equals[ii]
		as_list <- should_as_list(name, argument_list)
		argument <- convert_argument(argument_list[[ii]], as_list)
		proposed_arguments <- append(proposed_arguments, paste0(name, equal, argument))
	}
	# Make sure types are what Python wants
	if (mode == "add_argument" && any(grepl("type=", proposed_arguments))) {
		ii <- grep("type=", proposed_arguments)
		type <- argument_list[[ii]]
		proposed_arguments[ii] <- get_python_type(type, proposed_arguments)
	}
	# Don't put quotes around formatter_class argument
	if (mode == "ArgumentParser" && any(grepl("formatter_class=", proposed_arguments))) {
		ii <- grep("formatter_class=", proposed_arguments)
		formatter_class <- argument_list[[ii]]
		proposed_arguments[ii] <- sprintf("formatter_class=%s", formatter_class)
	}
	# Set right default prog name if not specified, if possible
	# Do last to not screw up other fixes with prog insertion
	if (mode == "ArgumentParser" && needs_prog(argument_names)) {
		prog <- get_Rscript_filename()
		if (is.na(prog)) {
			prog <- "PROGRAM"
		}
		proposed_arguments <- c(sprintf("prog='%s'", prog), proposed_arguments)
	}
	paste(proposed_arguments, collapse = ", ")
}

needs_prog <- function(argument_names) {
	if (length(argument_names) == 0L) {
		TRUE
	} else if (argument_names[1L] == "") {
		FALSE
	} else if (any(argument_names == "prog")) {
		FALSE
	} else {
		TRUE
	}
}

# Manually copied over from getopt to eliminate it as a dependency
get_Rscript_filename <- function() {
	prog <- sub("--file=", "", grep("--file=", commandArgs(), value = TRUE)[1])
	if (.Platform$OS.type == "windows") {
		prog <- gsub("\\\\", "\\\\\\\\", prog)
	}
	prog
}

# Internal function to check python cmd is okay
# @param python_cmd Python cmd to use
assert_python_cmd <- function(python_cmd) {
	if (
		!findpython::is_python_sufficient(
			python_cmd,
			required_modules = c("argparse", "json | simplejson")
		)
	) {
		stop(paste(
			sprintf("python executable %s either is not installed,", python_cmd),
			"is not on the path, or does not have argparse, json modules",
			"please see INSTALL file"
		))
	}
}

required_modules <- c("argparse", "json | simplejson")

detects_python <- function(...) {
	python_cmd <- try(find_python_cmd())
	!inherits(python_cmd, "try-error") &&
		findpython::is_python_sufficient(python_cmd, ..., required_modules = required_modules)
}

# Internal function to find python cmd
# @param python_cmd  Python cmd to use
find_python_cmd <- function(python_cmd = NULL) {
	if (is.null(python_cmd)) {
		python_cmd <- getOption("python_cmd")
	}
	if (is.null(python_cmd)) {
		did_find_python3 <- findpython::can_find_python_cmd(
			minimum_version = "3.0",
			required_modules = required_modules,
			silent = TRUE
		)
		if (did_find_python3) {
			python_cmd <- attr(did_find_python3, "python_cmd")
		} else {
			python_cmd <- findpython::find_python_cmd(required_modules = required_modules)
		}
	}
	python_cmd <- normalizePath(python_cmd, mustWork = FALSE)
	python_cmd
}

quieter_error_handler <- function(e) {
	quit('no', status = 1, runLast = FALSE)
}

pa_stop <- function(message, r_note) {
	msg <- paste(c(r_note, message), collapse = "\n")
	cnd <- errorCondition(
		msg,
		call = "argparse::parse_args_output(output)",
		class = "argparse_parse_error"
	)
	if (interactive()) {
		stop(cnd)
	} else {
		signalCondition(cnd)
		cat(message, sep = "\n", file = stderr())
		opt <- options(
			error = getOption("error", quieter_error_handler),
			show.error.messages = FALSE
		)
		on.exit(options(opt))
		stop(cnd)
	}
}

# Internal function to print message
print_message_and_exit <- function(message, r_note) {
	if (interactive()) {
		pa_stop(message, r_note)
	} else {
		cat(message, sep = "\n")
		quit(status = 0L)
	}
}

# Copyright (c) 2012-2024 Trevor L Davis <trevor.l.davis@gmail.com>
#
#  This file is free software: you may copy, redistribute and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation, either version 2 of the License, or (at your
#  option) any later version.
#
#  This file is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This file incorporates work from the argparse module in Python 2.7.3.
#
#     Copyright (c) 1990-2012 Python Software Foundation; All Rights Reserved
#
# See (inst/)COPYRIGHTS or http://docs.python.org/2/license.html for the full
# Python (GPL-compatible) license stack.
test_that("print_help works as expected", {
	skip_if_not(detects_python())
	parser <- ArgumentParser(description = "Process some integers.")
	expect_output(parser$print_help(), "usage:")
	expect_output(parser$print_help(), "optional arguments:|options:")
	expect_output(parser$print_help(), "Process some integers.")
	expect_output(parser$print_usage(), "usage:")
	expect_true(grepl("Process some integers.", parser$format_help()))
	expect_true(grepl("usage:", parser$format_usage()))

	# Request/bug by PlasmaBinturong
	parser$add_argument(
		"integers",
		metavar = "N",
		type = "integer",
		nargs = "+",
		help = "an integer for the accumulator"
	)
	expect_error(capture.output(parser$parse_args(), "parse error"))

	if (!interactive()) {
		skip("interactive() == FALSE")
	}
	expect_error(capture.output(parser$parse_args("-h")), "help requested")
})

test_that("`convert_argument()` works as expected", {
	skip_if_not(detects_python())
	expect_equal(convert_argument("foobar"), 'r"""foobar"""')
	expect_equal(convert_argument(14.9), "14.9")
	expect_equal(convert_argument(c(12.1, 14.9)), "(12.1, 14.9)")
	expect_equal(convert_argument(c("a", "b")), '(r"""a""", r"""b""")')
})

test_that("`convert_..._to_arguments()` works as expected", {
	skip_if_not(detects_python())
	# test in mode "add_argument"
	c.2a <- function(...) convert_..._to_arguments("add_argument", ...)
	waz <- "wazzup"
	expect_equal(c.2a(foo = "bar", hello = "world"), 'foo=r"""bar""", hello=r"""world"""')
	expect_equal(c.2a(foo = "bar", waz), 'foo=r"""bar""", r"""wazzup"""')
	expect_equal(c.2a(type = "character"), "type=str")
	expect_equal(c.2a(default = TRUE), "default=True")
	expect_equal(c.2a(default = 3.4), "default=3.4")
	expect_equal(c.2a(default = "foo"), 'default=r"""foo"""')
	# test in mode "ArgumentParser"
	c.2a <- function(...) convert_..._to_arguments("ArgumentParser", ...)
	expect_match(c.2a(argument_default = FALSE), "argument_default=False")
	expect_match(c.2a(argument_default = 30), "argument_default=30")
	expect_match(c.2a(argument_default = "foobar"), 'argument_default=r"""foobar"""')
	expect_match(c.2a(foo = "bar"), "^prog='PROGRAM'|^prog='test-argparse.R'")
	expect_match(
		c.2a(formatter_class = "argparse.ArgumentDefaultsHelpFormatter"),
		"formatter_class=argparse.ArgumentDefaultsHelpFormatter"
	)
})

test_that("`add_argument()` works as expected", {
	skip_if_not(detects_python())
	parser <- ArgumentParser()
	parser$add_argument(
		"integers",
		metavar = "N",
		type = "integer",
		nargs = "+",
		help = "an integer for the accumulator"
	)
	parser$add_argument(
		"--sum",
		dest = "accumulate",
		action = "store_const",
		const = "sum",
		default = "max",
		help = "sum the integers (default: find the max)"
	)
	arguments <- parser$parse_args(c("--sum", "1", "2"))
	f <- get(arguments$accumulate)
	expect_output(parser$print_help(), "sum the integers")
	expect_equal(arguments$accumulate, "sum")
	expect_equal(arguments$integers, c(1, 2))
	expect_equal(f(arguments$integers), 3)
	expect_error(parser$add_argument("--foo", type = "boolean"))

	# Bug found by Martin Diehl
	parser$add_argument(
		"--label",
		type = "character",
		nargs = 2,
		dest = "label",
		action = "store",
		default = c("a", "b"),
		help = "label for X and Y axis"
	)
	suppressWarnings(parser$add_argument(
		"--bool",
		type = "logical",
		nargs = 2,
		dest = "bool",
		action = "store",
		default = c(FALSE, TRUE)
	))
	arguments <- parser$parse_args(c("--sum", "1", "2"))
	expect_equal(arguments$label, c("a", "b"))
	expect_equal(arguments$bool, c(FALSE, TRUE))

	# Bug found by Oliver Dreschel (@oliverdreschel)
	p <- ArgumentParser()
	p$add_argument(
		'--listlab',
		type = 'character',
		help = 'This is a helpstring,"Containing Quotes"'
	)
	expect_equal(p$parse_args()$listlab, NULL)

	# Use R casting of logicals
	p <- ArgumentParser()
	p$add_argument("--bool", type = "logical", action = "store")
	expect_false(p$parse_args("--bool=F")$bool)
	expect_true(p$parse_args("--bool=T")$bool)
	expect_error(p$parse_args("--bool=1")$bool)

	# Use R casting of logicals with type append
	p <- ArgumentParser()
	p$add_argument("--bool", type = "logical", action = "append")
	expect_equal(p$parse_args(c("--bool=F", "--bool=true", "--bool=T"))$bool, c(FALSE, TRUE, TRUE))
	expect_error(p$parse_args(c("--bool=F", "--bool=1", "--bool=T"))$bool)

	# Bug/Feature request found by Hyunsoo Kim
	p <- ArgumentParser()
	p$add_argument("--test", default = NULL)
	expect_equal(p$parse_args()$test, NULL)

	# Feature request of Paul Newell
	parser <- ArgumentParser()
	parser$add_argument("extent", nargs = 4, type = "double", metavar = c("e1", "e2", "e3", "e4"))
	expect_output(parser$print_usage(), "usage: PROGRAM \\[-h\\] e1 e2 e3 e4")

	# Bug report by Claire D. McWhite
	parser <- ArgumentParser()
	parser$add_argument("-o", "--output_filename", required = FALSE, default = "outfile.txt")
	expect_equal(parser$parse_args()$output_filename, "outfile.txt")

	parser <- ArgumentParser()
	parser$add_argument("-o", "--output_filename", required = TRUE, default = "outfile.txt")
	expect_error(parser$parse_args())
})

test_that("version flags works as expected", {
	skip_if_not(detects_python())
	# Feature request of Dario Beraldi
	parser <- ArgumentParser()
	parser$add_argument("-v", "--version", action = "version", version = "1.0.1")
	if (interactive()) {
		expect_error(parser$parse_args("-v"), "version requested:\n1.0.1")
		expect_error(parser$parse_args("--version"), "version requested:\n1.0.1")
	}

	# empty list
	parser <- ArgumentParser()
	el <- parser$parse_args()
	expect_true(is.list(el))
	expect_equal(length(el), 0)
})

test_that("`parse_known_args()` works as expected", {
	skip_if_not(detects_python())
	parser <- ArgumentParser()
	parser$add_argument("-o", "--output_filename", default = "outfile.txt")
	a_r <- parser$parse_known_args(c("-o", "foobar.txt", "-n", "4"))
	expect_equal(a_r[[1]]$output_filename, "foobar.txt")
	expect_equal(a_r[[2]], c("-n", "4"))
})

test_that("`parse_intermixed_args()` works as expected", {
	skip_if_not(detects_python(minimum_version = '3.7'))
	parser <- ArgumentParser()
	parser$add_argument('--foo')
	parser$add_argument('cmd')
	parser$add_argument('rest', nargs = '*', type = 'integer')
	args <- strsplit('doit 1 --foo bar 2 3', ' ')[[1]]
	args <- parser$parse_intermixed_args(args)
	expect_equal(args$cmd, 'doit')
	expect_equal(args$foo, 'bar')
	expect_equal(args$rest, 1:3)
})

test_that("`parse_known_intermixed_args()` works as expected", {
	skip_if_not(detects_python(minimum_version = '3.7'))
	parser <- ArgumentParser()
	parser$add_argument('--foo')
	parser$add_argument('cmd')
	parser$add_argument('rest', nargs = '*', type = 'integer')
	args <- strsplit('doit 1 --foo bar 2 3 -n', ' ')[[1]]
	a_r <- parser$parse_known_intermixed_args(args)
	expect_equal(a_r[[1]]$cmd, 'doit')
	expect_equal(a_r[[1]]$foo, 'bar')
	expect_equal(a_r[[1]]$rest, 1:3)
	expect_equal(a_r[[2]], c('-n'))
})

test_that("`set_defaults()` works as expected", {
	skip_if_not(detects_python())
	parser <- ArgumentParser()
	parser$set_defaults(bar = 42)
	args <- parser$parse_args(c())
	expect_equal(args$bar, 42)

	expect_error(
		parser$get_default("bar"),
		"We don't currently support `get_default()`",
		fixed = TRUE
	)
})

test_that("`ArgumentParser()` works as expected", {
	skip_if_not(detects_python())
	parser <- ArgumentParser(prog = "foobar", usage = "%(prog)s arg1 arg2")
	parser$add_argument(
		"--hello",
		dest = "saying",
		action = "store_const",
		const = "hello",
		default = "bye",
		help = "%(prog)s's saying (default: %(default)s)"
	)
	expect_output(parser$print_help(), "foobar arg1 arg2")
	expect_output(parser$print_help(), "foobar's saying \\(default: bye\\)")
	expect_error(ArgumentParser(python_cmd = "foobar"))
	skip_if_not(interactive(), "Skip passing -h if not interactive()")
	# Bug report by George Chlipala
	expect_error(ArgumentParser()$parse_args("-h"), "help requested")
	expect_error(ArgumentParser(add_help = TRUE)$parse_args("-h"), "help requested")
	expect_error(ArgumentParser(add_help = FALSE)$parse_args("-h"), "unrecognized arguments")
})

test_that("`parse_args()` works as expected", {
	skip_if_not(detects_python())
	parser <- ArgumentParser("foobar", usage = "%(prog)s arg1 arg2")
	parser$add_argument(
		"--hello",
		dest = "saying",
		action = "store",
		default = "foo",
		choices = c("foo", "bar"),
		help = "%(prog)s's saying (default: %(default)s)"
	)
	expect_equal(parser$parse_args("--hello=bar"), list(saying = "bar"))
	expect_error(parser$parse_args("--hello=what"))

	# Unhelpful error message found by Martí Duran Ferrer
	parser <- ArgumentParser()
	parser$add_argument("M", required = TRUE, help = "Test")
	expect_error(parser$parse_args(), "python error")

	# bug reported by Dominik Mueller
	p <- argparse::ArgumentParser()
	p$add_argument("--int", type = "integer")
	p$add_argument("--double", type = "double")
	p$add_argument("--character", type = "character")
	p$add_argument("--numeric", type = "numeric")

	input <- "1"
	args <- p$parse_args(c(
		"--int",
		input,
		"--double",
		input,
		"--character",
		input,
		"--numeric",
		input
	))
	expect_equal(class(args$int), "integer")
	expect_equal(class(args$double), "numeric")
	expect_equal(class(args$character), "character")
	expect_equal(class(args$numeric), "numeric")
	expect_equal(args$int, as.integer(1.0))
	expect_equal(args$double, 1.0)
	expect_equal(args$character, "1")
	expect_equal(args$numeric, 1.0)

	# bug reported by Arthur Gilly
	parser <- ArgumentParser(description = "Description of tool.\nAuthor information.")
	expect_true(is.list(parser$parse_args()))

	# bug found my Matthew Hall (@mdhall272, #51)
	parser <- ArgumentParser(description = 'foo')
	parser$add_argument('--bar', default = "[\\D]")
	expect_equal(parser$parse_args()$bar, "[\\D]")

	# Bug found by Taylor Pospisil
	skip_on_os("windows") # Didn't work on Github Actions Windows
	skip_on_cran() # Once gave an error on win-builder
	parser <- ArgumentParser()
	parser$add_argument("--lotsofstuff", type = "character", nargs = "+")
	args <- parser$parse_args(c("--lotsofstuff", rep("stuff", 1000)))
	expect_equal(args$lotsofstuff, rep("stuff", 1000))

	# Bug found by @miker985
	test_that("we can action = 'append' with a default list", {
		parser <- argparse::ArgumentParser()
		parser$add_argument(
			"--test-dim",
			dest = "dims",
			action = "append",
			default = c("year", "sex", "age")
		)
		args <- parser$parse_args(c("--test-dim", "race"))

		expect_equal(args$dims, c("year", "sex", "age", "race"))
	})
})

# Bug found by Erick Rocha Fonseca
test_that("Unicode support works if Python and OS sufficient", {
	skip_if_not(detects_python())
	skip_on_os("windows") # Didn't work on win-builder
	skip_on_cran() # Didn't work on Debian Clang
	did_find_python3 <- findpython::can_find_python_cmd(
		minimum_version = "3.0",
		required_modules = c("argparse", "json|simplejson"),
		silent = TRUE
	)
	if (!did_find_python3) {
		skip("Need at least Python 3.0 for Unicode support")
	}
	p <- ArgumentParser(python_cmd = attr(did_find_python3, "python_cmd"))
	p$add_argument("name")
	expect_equal(p$parse_args("\u8292\u679C"), list(name = "\u8292\u679C")) # 芒果
})

test_that("Unicode attempt throws error if Python or OS not sufficient", {
	skip_if_not(detects_python())
	skip_on_os("windows") # Didn't work on AppVeyor
	skip_on_cran() # Didn't work on Debian Clang
	did_find_python2 <- findpython::can_find_python_cmd(
		maximum_version = "2.7",
		required_modules = c("argparse", "json|simplejson"),
		silent = TRUE
	)
	if (!did_find_python2) {
		skip("Need Python 2 to guarantee throws Unicode error")
	}
	p <- ArgumentParser(python_cmd = attr(did_find_python2, "python_cmd"))
	p$add_argument("name")
	expect_error(p$parse_args("\u8292\u679C"), "Non-ASCII character detected.") # 芒果
})

# Mutually exclusive groups is a feature request by Vince Reuter
test_that("mutually exclusive groups works as expected", {
	skip_if_not(detects_python())
	parser <- ArgumentParser(prog = "PROG")
	group <- parser$add_mutually_exclusive_group()
	group$add_argument("--foo", action = "store_true")
	group$add_argument("--bar", action = "store_false")
	arguments <- parser$parse_args("--foo")
	expect_true(arguments$bar)
	expect_true(arguments$foo)
	arguments <- parser$parse_args("--bar")
	expect_false(arguments$bar)
	expect_false(arguments$foo)
	expect_error(
		parser$parse_args(c("--foo", "--bar")),
		"argument --bar: not allowed with argument --foo"
	)

	parser <- ArgumentParser(prog = "PROG")
	group <- parser$add_mutually_exclusive_group(required = TRUE)
	group$add_argument("--foo", action = "store_true")
	group$add_argument("--bar", action = "store_false")
	expect_error(parser$parse_args(character()), " one of the arguments --foo --bar is required")
})

# argument groups is a feature request by Dario Beraldi
test_that("add argument group works as expected", {
	skip_if_not(detects_python())
	parser <- ArgumentParser(prog = "PROG", add_help = FALSE)
	group1 <- parser$add_argument_group("group1", "group1 description")
	group1$add_argument("foo", help = "foo help")
	group2 <- parser$add_argument_group("group2", "group2 description")
	group2$add_argument("--bar", help = "bar help")
	expect_output(parser$print_help(), "group1 description")
	expect_output(parser$print_help(), "group2 description")
})

# subparser support is a feature request by Zebulun Arendsee
test_that("sub parsers work as expected", {
	skip_if_not(detects_python())
	# create the top-level parser
	parser <- ArgumentParser(prog = "PROG")
	parser$add_argument("--foo", action = "store_true", help = "foo help")
	subparsers <- parser$add_subparsers(help = "sub-command help")

	# create the parser for the "a" command
	parser_a <- subparsers$add_parser("a", help = "a help")
	parser_a$add_argument("bar", type = "integer", help = "bar help")

	# create the parser for the "b" command
	parser_b <- subparsers$add_parser("b", help = "b help")
	parser_b$add_argument("--baz", choices = "XYZ", help = "baz help")

	# parse some argument lists
	arguments <- parser$parse_args(c("a", "12"))
	expect_equal(arguments$bar, 12)
	expect_equal(arguments$foo, FALSE)
	arguments <- parser$parse_args(c("--foo", "b", "--baz", "Z"))
	expect_equal(arguments$baz, "Z")
	expect_equal(arguments$foo, TRUE)
	expect_output(parser$print_help(), "sub-command help")
	expect_output(parser_a$print_help(), "usage: PROG a")
	expect_output(parser_b$print_help(), "usage: PROG b")
})

# Group.add_mutually_exclusive_group request by Brar Piening
test_that("`Group.add_mutually_exclusive_group()`", {
	skip_if_not(detects_python())
	# create the top-level parser
	parser <- ArgumentParser(prog = "PROG")
	group1 <- parser$add_argument_group(
		title = "Group title",
		description = "Group description"
	)
	group2 <- group1$add_mutually_exclusive_group()
	group2$add_argument("--foo", help = "foo help")
	group2$add_argument("--bar", help = "bar help")
	expect_output(parser$print_help(), "Group description")
})

test_that("Paths that `quit()`", {
	skip_if_not(detects_python())
	skip_on_os("windows")
	cmd <- file.path(R.home(), "bin/Rscript")
	skip_if(Sys.which(cmd) == "")

	expect_equal(system2(cmd, c("scripts/test_version.R", "--version"), stdout = TRUE), "1.0.1")

	help <- system2(cmd, c("scripts/test_help.R", "--help"), stdout = TRUE, stderr = TRUE)
	expect_equal("usage: scripts/test_help.R [-h]", help[1])
	expect_equal("  -h, --help  show this help message and exit", help[4])
})

# Copyright (c) 2012-2021 Trevor L Davis <trevor.l.davis@gmail.com>
#
#  This file is free software: you may copy, redistribute and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation, either version 2 of the License, or (at your
#  option) any later version.
#
#  This file is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This file incorporates work from the argparse module in Python 2.7.3.
#
#     Copyright (c) 1990-2012 Python Software Foundation; All Rights Reserved
#
# See (inst/)COPYRIGHTS or http://docs.python.org/2/license.html for the full
# Python (GPL-compatible) license stack.
test_that("print_help works as expected", {
    skip_if_not(detects_python())
    parser <- ArgumentParser(description = "Process some integers.")
    expect_output(parser$print_help(), "usage:")
    expect_output(parser$print_help(), "optional arguments:|options:")
    expect_output(parser$print_help(), "Process some integers.")
    expect_output(parser$print_usage(), "usage:")
    expect_true(grepl("Process some integers.", parser$format_help()))
    expect_true(grepl("usage:", parser$format_usage()))

    # Request/bug by PlasmaBinturong
    parser$add_argument("integers", metavar = "N", type = "integer", nargs = "+",
                       help = "an integer for the accumulator")
    expect_error(capture.output(parser$parse_args(), "parse error"))

    if (!interactive()) skip("interactive() == FALSE")
    expect_error(capture.output(parser$parse_args("-h")), "help requested")
})

test_that("convert_argument works as expected", {
    skip_if_not(detects_python())
    expect_equal(convert_argument("foobar"), '"""foobar"""')
    expect_equal(convert_argument(14.9), "14.9")
    expect_equal(convert_argument(c(12.1, 14.9)), "(12.1, 14.9)")
    expect_equal(convert_argument(c("a", "b")), '("""a""", """b""")')
})

test_that("convert_..._to_arguments works as expected", {
    skip_if_not(detects_python())
    # test in mode "add_argument"
    c.2a <- function(...) convert_..._to_arguments("add_argument", ...)
    waz <- "wazzup"
    expect_equal(c.2a(foo = "bar", hello = "world"), 'foo="""bar""", hello="""world"""')
    expect_equal(c.2a(foo = "bar", waz), 'foo="""bar""", """wazzup"""')
    expect_equal(c.2a(type = "character"), "type=str")
    expect_equal(c.2a(default = TRUE), "default=True")
    expect_equal(c.2a(default = 3.4), "default=3.4")
    expect_equal(c.2a(default = "foo"), 'default="""foo"""')
    # test in mode "ArgumentParser"
    c.2a <- function(...) convert_..._to_arguments("ArgumentParser", ...)
    expect_match(c.2a(argument_default = FALSE), "argument_default=False")
    expect_match(c.2a(argument_default = 30), "argument_default=30")
    expect_match(c.2a(argument_default = "foobar"), 'argument_default="""foobar"""')
    expect_match(c.2a(foo = "bar"), "^prog='PROGRAM'|^prog='test-argparse.R'")
    expect_match(c.2a(formatter_class = "argparse.ArgumentDefaultsHelpFormatter"),
                 "formatter_class=argparse.ArgumentDefaultsHelpFormatter")
})

test_that("add_argument works as expected", {
    skip_if_not(detects_python())
    parser <- ArgumentParser()
    parser$add_argument("integers", metavar = "N", type = "integer", nargs = "+",
                       help = "an integer for the accumulator")
    parser$add_argument("--sum", dest = "accumulate", action = "store_const",
                       const = "sum", default = "max",
                       help = "sum the integers (default: find the max)")
    arguments <- parser$parse_args(c("--sum", "1", "2"))
    f <- get(arguments$accumulate)
    expect_output(parser$print_help(), "sum the integers")
    expect_equal(arguments$accumulate, "sum")
    expect_equal(arguments$integers, c(1, 2))
    expect_equal(f(arguments$integers), 3)
    expect_error(parser$add_argument("--foo", type = "boolean"))

    # Bug found by Martin Diehl
    parser$add_argument("--label", type = "character", nargs = 2,
        dest = "label", action = "store", default = c("a", "b"), help = "label for X and Y axis")
    suppressWarnings(parser$add_argument("--bool", type = "logical", nargs = 2,
        dest = "bool", action = "store", default = c(FALSE, TRUE)))
    arguments <- parser$parse_args(c("--sum", "1", "2"))
    expect_equal(arguments$label, c("a", "b"))
    expect_equal(arguments$bool, c(FALSE, TRUE))

    # Use R casting of logicals
    p <- ArgumentParser()
    p$add_argument("--bool", type = "logical", action = "store")
    expect_false(p$parse_args("--bool=F")$bool)
    expect_true(p$parse_args("--bool=T")$bool)
    expect_error(p$parse_args("--bool=1")$bool)

    # Use R casting of logicals with type append
    p <- ArgumentParser()
    p$add_argument("--bool", type = "logical", action = "append")
    expect_equal(p$parse_args(c("--bool=F", "--bool=true", "--bool=T"))$bool,
                 c(FALSE, TRUE, TRUE))
    expect_error(p$parse_args(c("--bool=F", "--bool=1", "--bool=T"))$bool)

    # Bug/Feature request found by Hyunsoo Kim
    p <- ArgumentParser()
    p$add_argument("--test", default = NULL)
    expect_equal(p$parse_args()$test, NULL)

    # Feature request of Paul Newell
    parser <- ArgumentParser()
    parser$add_argument("extent", nargs = 4, type = "double", metavar = c("e1", "e2", "e3", "e4"))
    expect_output(parser$print_usage(), "usage: PROGRAM \\[-h\\] e1 e2 e3 e4")

    # Bug report by Claire D. McWhite
    parser <- ArgumentParser()
    parser$add_argument("-o", "--output_filename", required = FALSE, default = "outfile.txt")
    expect_equal(parser$parse_args()$output_filename, "outfile.txt")

    parser <- ArgumentParser()
    parser$add_argument("-o", "--output_filename", required = TRUE, default = "outfile.txt")
    expect_error(parser$parse_args())
})

test_that("version flags works as expected", {
    skip_if_not(detects_python())
    # Feature request of Dario Beraldi
    parser <- ArgumentParser()
    parser$add_argument("-v", "--version", action = "version", version = "1.0.1")
    if (interactive()) {
        expect_error(parser$parse_args("-v"), "version requested:\n1.0.1")
        expect_error(parser$parse_args("--version"), "version requested:\n1.0.1")
    }

    # empty list
    parser <- ArgumentParser()
    el <- parser$parse_args()
    expect_true(is.list(el))
    expect_equal(length(el), 0)
})

test_that("parse_known_args() works as expected", {
    skip_if_not(detects_python())
    parser <- ArgumentParser()
    parser$add_argument("-o", "--output_filename", default = "outfile.txt")
    a_r <- parser$parse_known_args(c("-o", "foobar.txt", "-n", "4"))
    expect_equal(a_r[[1]]$output_filename, "foobar.txt")
    expect_equal(a_r[[2]], c("-n", "4"))

})

test_that("parse_intermixed_args() works as expected", {
    skip_if_not(detects_python())
    parser <- ArgumentParser()
    parser$add_argument('--foo')
    parser$add_argument('cmd')
    parser$add_argument('rest', nargs='*', type='integer')
    args <- strsplit('doit 1 --foo bar 2 3', ' ')[[1]]
    args <- parser$parse_intermixed_args(args)
    expect_equal(args$cmd, 'doit')
    expect_equal(args$foo, 'bar')
    expect_equal(args$rest, 1:3)

    args <- strsplit('doit 1 --foo bar 2 3 -n 4', ' ')[[1]]
    a_r <- parser$parse_known_intermixed_args(args)
    expect_equal(a_r[[1]]$cmd, 'doit')
    expect_equal(a_r[[1]]$foo, 'bar')
    expect_equal(a_r[[1]]$rest, 1:3)
    expect_equal(a_r[[2]], c('-n', '4'))
})

test_that("set_defaults() works as expected", {
    skip_if_not(detects_python())
    parser <- ArgumentParser()
    parser$set_defaults(bar=42)
    args <- parser$parse_args(c())
    expect_equal(args$bar, 42)

    # expect_equal(parser$get_default("bar"), 42)
})

test_that("ArgumentParser works as expected", {
    skip_if_not(detects_python())
    parser <- ArgumentParser(prog = "foobar", usage = "%(prog)s arg1 arg2")
    parser$add_argument("--hello", dest = "saying", action = "store_const",
            const = "hello", default = "bye",
            help = "%(prog)s's saying (default: %(default)s)")
    expect_output(parser$print_help(), "foobar arg1 arg2")
    expect_output(parser$print_help(), "foobar's saying \\(default: bye\\)")
    expect_error(ArgumentParser(python_cmd = "foobar"))
    skip_if_not(interactive(), "Skip passing -h if not interactive()")
    # Bug report by George Chlipala
    expect_error(ArgumentParser()$parse_args("-h"), "help requested")
    expect_error(ArgumentParser(add_help = TRUE)$parse_args("-h"), "help requested")
    expect_error(ArgumentParser(add_help = FALSE)$parse_args("-h"), "unrecognized arguments")
})

test_that("parse_args() works as expected", {
    skip_if_not(detects_python())
    parser <- ArgumentParser("foobar", usage = "%(prog)s arg1 arg2")
    parser$add_argument("--hello", dest = "saying", action = "store", default = "foo",
            choices = c("foo", "bar"),
            help = "%(prog)s's saying (default: %(default)s)")
    expect_equal(parser$parse_args("--hello=bar"), list(saying = "bar"))
    expect_error(parser$parse_args("--hello=what"))

    # Unhelpful error message found by Martí Duran Ferrer
    parser <- ArgumentParser()
    parser$add_argument("M", required = TRUE, help = "Test")
    expect_error(parser$parse_args(), "python error")


    # bug reported by Dominik Mueller
    p <- argparse::ArgumentParser()
    p$add_argument("--int", type = "integer")
    p$add_argument("--double", type = "double")
    p$add_argument("--character", type = "character")
    p$add_argument("--numeric", type = "numeric")

    input <- "1"
    args <- p$parse_args(c("--int", input,
                           "--double", input,
                           "--character", input,
                           "--numeric", input))
    expect_equal(class(args$int), "integer")
    expect_equal(class(args$double), "numeric")
    expect_equal(class(args$character), "character")
    expect_equal(class(args$numeric), "numeric")
    expect_equal(args$int, as.integer(1.0))
    expect_equal(args$double, 1.0)
    expect_equal(args$character, "1")
    expect_equal(args$numeric, 1.0)

    # bug reported by Arthur Gilly
    parser <- ArgumentParser(description="Description of tool.\nAuthor information.")
    expect_true(is.list(parser$parse_args()))

    # Bug found by Taylor Pospisil
    skip_on_os("windows") # Didn't work on Github Actions Windows
    skip_on_cran() # Once gave an error on win-builder
    parser <- ArgumentParser()
    parser$add_argument("--lotsofstuff", type = "character", nargs = "+")
    args <- parser$parse_args(c("--lotsofstuff", rep("stuff", 1000)))
    expect_equal(args$lotsofstuff, rep("stuff", 1000))

    # Bug found by @miker985
    test_that("we can action = 'append' with a default list", {
        parser <- argparse::ArgumentParser()
        parser$add_argument("--test-dim", dest = "dims", action = "append",
                            default = c("year", "sex", "age"))
        args <- parser$parse_args(c("--test-dim", "race"))

        expect_equal(args$dims, c("year", "sex", "age", "race"))
    })
})

# Bug found by Erick Rocha Fonseca
test_that("Unicode support works if Python and OS sufficient", {
    skip_if_not(detects_python())
    skip_on_os("windows") # Didn't work on win-builder
    skip_on_cran() # Didn't work on Debian Clang
    did_find_python3 <- findpython::can_find_python_cmd(minimum_version = "3.0",
                                    required_modules = c("argparse", "json|simplejson"),
                                    silent = TRUE)
    if (!did_find_python3) skip("Need at least Python 3.0 for Unicode support")
    p <- ArgumentParser(python_cmd = attr(did_find_python3, "python_cmd"))
    p$add_argument("name")
    expect_equal(p$parse_args("\u8292\u679C"), list(name = "\u8292\u679C")) # 芒果
})

test_that("Unicode attempt throws error if Python or OS not sufficient", {
    skip_if_not(detects_python())
    skip_on_os("windows") # Didn't work on AppVeyor
    skip_on_cran() # Didn't work on Debian Clang
    did_find_python2 <- findpython::can_find_python_cmd(maximum_version = "2.7",
                                    required_modules = c("argparse", "json|simplejson"),
                                    silent = TRUE)
    if (!did_find_python2) skip("Need Python 2 to guarantee throws Unicode error")
    p <- ArgumentParser(python_cmd = attr(did_find_python2, "python_cmd"))
    p$add_argument("name")
    expect_error(p$parse_args("\u8292\u679C"), "Non-ASCII character detected.") # 芒果

})

# Mutually exclusive groups is a feature request by Vince Reuter
test_that("mutually exclusive groups works as expected", {
    skip_if_not(detects_python())
    parser <- ArgumentParser(prog = "PROG")
    group <- parser$add_mutually_exclusive_group()
    group$add_argument("--foo", action = "store_true")
    group$add_argument("--bar", action = "store_false")
    arguments <- parser$parse_args("--foo")
    expect_true(arguments$bar)
    expect_true(arguments$foo)
    arguments <- parser$parse_args("--bar")
    expect_false(arguments$bar)
    expect_false(arguments$foo)
    expect_error(parser$parse_args(c("--foo", "--bar")), "argument --bar: not allowed with argument --foo")

    parser <- ArgumentParser(prog = "PROG")
    group <- parser$add_mutually_exclusive_group(required = TRUE)
    group$add_argument("--foo", action = "store_true")
    group$add_argument("--bar", action = "store_false")
    expect_error(parser$parse_args(character()), " one of the arguments --foo --bar is required")
})

# argument groups is a feature request by Dario Beraldi
test_that("add argument group works as expected", {
    skip_if_not(detects_python())
    parser <- ArgumentParser(prog = "PROG", add_help = FALSE)
    group1 <- parser$add_argument_group("group1", "group1 description")
    group1$add_argument("foo", help = "foo help")
    group2 <- parser$add_argument_group("group2", "group2 description")
    group2$add_argument("--bar", help = "bar help")
    expect_output(parser$print_help(), "group1 description")
    expect_output(parser$print_help(), "group2 description")
})

# subparser support is a feature request by Zebulun Arendsee
test_that("sub parsers work as expected", {
    skip_if_not(detects_python())
    # create the top-level parser
    parser <- ArgumentParser(prog = "PROG")
    parser$add_argument("--foo", action = "store_true", help = "foo help")
    subparsers <- parser$add_subparsers(help = "sub-command help")

    # create the parser for the "a" command
    parser_a <- subparsers$add_parser("a", help = "a help")
    parser_a$add_argument("bar", type = "integer", help = "bar help")

    # create the parser for the "b" command
    parser_b <- subparsers$add_parser("b", help = "b help")
    parser_b$add_argument("--baz", choices = "XYZ", help = "baz help")

    # parse some argument lists
    arguments <- parser$parse_args(c("a", "12"))
    expect_equal(arguments$bar, 12)
    expect_equal(arguments$foo, FALSE)
    arguments <- parser$parse_args(c("--foo", "b", "--baz", "Z"))
    expect_equal(arguments$baz, "Z")
    expect_equal(arguments$foo, TRUE)
    expect_output(parser$print_help(), "sub-command help")
    expect_output(parser_a$print_help(), "usage: PROG a")
    expect_output(parser_b$print_help(), "usage: PROG b")
})

test_that("Paths that quit()", {
    skip_if_not(detects_python())
    skip_on_os("windows")
    cmd <- file.path(R.home(), "bin/Rscript")
    skip_if(Sys.which(cmd) == "")

    expect_equal(system2(cmd, c("scripts/test_version.R", "--version"), stdout = TRUE),
                 "1.0.1")

    help <- system2(cmd, c("scripts/test_help.R", "--help"),
                    stdout = TRUE, stderr = TRUE)
    expect_equal("usage: scripts/test_help.R [-h]", help[1])
    expect_equal("  -h, --help  show this help message and exit", help[4])
})

# Copyright (c) 2012-2021 Trevor L. Davis <trevor.l.davis@gmail.com>
#
#  This file is free software: you may copy, redistribute and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation, either version 2 of the License, or (at your
#  option) any later version.
#
#  This file is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This file incorporates work from the argparse module in Python 2.7.3.
#
#     Copyright (c) 2001-2012 Python Software Foundation; All Rights Reserved
#
# See (inst/)COPYRIGHTS or http://docs.python.org/2/license.html for the full
# Python (GPL-compatible) license stack.

#' Create a command line parser
#'
#' \code{ArgumentParser} creates a parser object that acts as
#' a wrapper to Python's argparse module
#'
#' @param ... Arguments cleaned and passed to Pythons argparse.ArgumentParser()
#' @param python_cmd Python executable for \code{argparse} to use.
#'      Must have argparse and json modules (automatically included Python 2.7 and 3.2+).
#'      If you need Unicode argument support then you must use Python 3.0+.
#'      Default will be to use \code{findpython} package to find suitable Python binary.
#' @return  \code{ArgumentParser} returns a parser object which contains
#'    an \code{add_argument} function to add arguments to the parser,
#'    a \code{parse_args} function to parse command line arguments into
#'    a list, a \code{print_help} and \code{print_usage} function to print
#'    usage information.  See code examples, package vignette,
#'    and corresponding python module for more information on how to use it.
#'
#' @references Python's \code{argparse} library, which this package is based on,
#'  is described here: \url{https://docs.python.org/3/library/argparse.html}
#'
#' @import jsonlite
#' @import R6
#' @export
#' @examples
#'
#' if (argparse:::detects_python()) {
#'   parser <- ArgumentParser(description='Process some integers')
#'   parser$add_argument('integers', metavar='N', type = "integer", nargs='+',
#'                      help='an integer for the accumulator')
#'   parser$add_argument('--sum', dest='accumulate', action='store_const',
#'                      const='sum', default='max',
#'                      help='sum the integers (default: find the max)')
#'   parser$print_help()
#'   # default args for ArgumentParser()$parse_args are commandArgs(TRUE)
#'   # which is what you'd want for an Rscript but not for interactive use
#'   args <- parser$parse_args(c("--sum", "1", "2", "3"))
#'   accumulate_fn <- get(args$accumulate)
#'   print(accumulate_fn(args$integers))
#' }
ArgumentParser <- function(..., python_cmd = NULL) { # nolint
    python_cmd <- find_python_cmd(python_cmd)
    assert_python_cmd(python_cmd)
    initial_python_code <- c("import argparse",
        "try:",
        "    import json",
        "except ImportError:",
        "    import simplejson as json",
        "",
        "def logical(s):",
        "    if isinstance(s, bool):",
        "        return s",
        "    elif s in ('T', 'TRUE', 'True', 'true'):",
        "        return True",
        "    elif s in ('F', 'FALSE', 'False', 'false'):",
        "        return False",
        "    else:",
        "        raise ValueError(\"could not convert string to logical: '{}'\".format(s))",
        "",
        sprintf("parser = argparse.ArgumentParser(%s)",
                convert_..._to_arguments("ArgumentParser", ...)),
        "")
    Parser$new(Code$new(python_cmd, initial_python_code), "parser")
}

Code <- R6Class("Code", # nolint
    public = list(
        append = function(new_code) {
            private$code <- c(private$code, new_code)
        },
        run = function(new_code) {
            code <- c(private$code, new_code)
            suppressWarnings(system2(private$cmd, input = code,
                                    stdout = TRUE, stderr = TRUE))
        },
        initialize = function(cmd, code = character(0)) {
            private$cmd <- cmd
            private$code <- code
        }
    ),
    private = list(code = NULL, cmd = NULL)
)

Group <- R6Class("Group", # nolint
    public = list(
        initialize = function(python_code, name) {
            private$python_code <- python_code
            private$name <- name
        },
        add_argument = function(...) {
            private$python_code$append(sprintf("%s.add_argument(%s)",
                private$name, convert_..._to_arguments("add_argument", ...)))
            return(invisible(NULL))
        }
    ),
    private = list(python_code = NULL, name = NULL)
)

Subparsers <- R6Class("Subparsers", # nolint
    public = list(
        initialize = function(python_code, name) {
            private$python_code <- python_code
            private$name <- name
        },
        add_parser = function(...) {
            parser_name <- paste0(private$name, "_subparser", private$n_subparsers)
            private$n_subparsers <- private$n_subparsers + 1
            private$python_code$append(sprintf("%s = %s.add_parser(%s)",
                            parser_name, private$name,
                            convert_..._to_arguments("ArgumentParser", ...)))
            Parser$new(private$python_code, parser_name)
        }
    ),
    private = list(python_code = NULL, name = NULL, n_subparsers = 0)
)

Parser <- R6Class("Parser", # nolint
    public = list(
        parse_args = function(args = commandArgs(TRUE)) {
            new_code <- c(sprintf("args = %s.parse_args([%s])", private$name,
                            paste(sprintf("'%s'", args), collapse = ", ")),
                    "print(json.dumps(args.__dict__, sort_keys=True))")
            output <- private$python_code$run(new_code)
            parse_args_output(output)
        },
        parse_intermixed_args = function(args = commandArgs(TRUE)) {
            new_code <- c(sprintf("args = %s.parse_intermixed_args([%s])", private$name,
                            paste(sprintf("'%s'", args), collapse = ", ")),
                    "print(json.dumps(args.__dict__, sort_keys=True))")
            output <- private$python_code$run(new_code)
            parse_args_output(output)
        },
        parse_known_args = function(args = commandArgs(TRUE)) {
            new_code <- c(sprintf("args_remainder = %s.parse_known_args([%s])", private$name,
                            paste(sprintf("'%s'", args), collapse = ", ")),
                    "print(json.dumps((args_remainder[0].__dict__, args_remainder[1])))")
            output <- private$python_code$run(new_code)
            parse_args_output(output)
        },
        parse_known_intermixed_args = function(args = commandArgs(TRUE)) {
            new_code <- c(sprintf("args_remainder = %s.parse_known_intermixed_args([%s])", private$name,
                            paste(sprintf("'%s'", args), collapse = ", ")),
                    "print(json.dumps((args_remainder[0].__dict__, args_remainder[1])))")
            output <- private$python_code$run(new_code)
            parse_args_output(output)
        },
        format_help = function() {
            paste(private$python_code$run(sprintf("%s.print_help()", private$name)),
                  collapse = "\n")
        },
        format_usage = function() {
            paste(private$python_code$run(sprintf("%s.print_usage()", private$name)),
                  collapse = "\n")
        },
        print_help = function() {
            cat(private$python_code$run(sprintf("%s.print_help()", private$name)), sep = "\n")
            invisible(NULL)
        },
        print_usage = function() {
            cat(private$python_code$run(sprintf("%s.print_usage()", private$name)), sep = "\n")
            invisible(NULL)
        },
        get_default = function(...) {
            stop("We don't currently support `get_default()`")
        },
        set_defaults = function(...) {
            private$python_code$append(sprintf("%s.set_defaults(%s)", private$name,
                            convert_..._to_arguments("add_argument", ...)))
            invisible(NULL)
        },
        add_argument = function(...) {
            private$python_code$append(sprintf("%s.add_argument(%s)", private$name,
                            convert_..._to_arguments("add_argument", ...)))
            invisible(NULL)
        },
        add_argument_group = function(...) {
            group_name <- paste0(private$name, "_group", private$n_groups)
            private$n_groups <- private$n_groups + 1
            private$python_code$append(sprintf("%s = %s.add_argument_group(%s)",
                           group_name, private$name,
                            convert_..._to_arguments("add_argument", ...)))
            Group$new(private$python_code, group_name)
        },
        add_mutually_exclusive_group = function(required = FALSE) {
            group_name <- paste0(private$name, "_mutually_exclusive_group",
                                 private$n_mutually_exclusive_groups)
            private$n_mutually_exclusive_groups <- private$n_mutually_exclusive_groups + 1
            private$python_code$append(sprintf("%s = %s.add_mutually_exclusive_group(%s)",
                           group_name, private$name,
                           ifelse(required, "required=True", "")))
            Group$new(private$python_code, group_name)
        },
        add_subparsers = function(...) {
            subparsers_name <- paste0(private$name, "_subparsers")
            private$python_code$append(sprintf("%s = %s.add_subparsers(%s)",
                            subparsers_name, private$name,
                            convert_..._to_arguments("add_argument", ...)))
            Subparsers$new(private$python_code, subparsers_name)
        },
        initialize = function(python_code, name) {
            private$python_code <- python_code
            private$name <- name
        }
    ),
    private = list(python_code = NULL, name = NULL,
                   n_mutually_exclusive_groups = 0, n_groups = 0)
)

parse_args_output <- function(output) {
    if (grepl("^usage:", output[1])) {
        has_positional_arguments <- any(grepl("^positional arguments:", output))
        has_optional_arguments <- any(grepl("^optional arguments:|^options:", output))
        if (has_positional_arguments || has_optional_arguments) {
            print_message_and_exit(output, "help requested:")
        } else {
            pa_stop(output, "parse error:")
        }
    } else if (grepl("^Traceback", output[1])) {
        pa_stop(output, "python error:")
    } else if (any(grepl("^SyntaxError: Non-ASCII character", output))) {
        message <- paste("Non-ASCII character detected.",
                       "If you wish to use Unicode arguments/options",
                       "please upgrade to Python 3.2+",
                       "Please see file INSTALL for more details.")
        pa_stop(message, "non-ascii character error:")
    } else if (any(grepl("^SyntaxError: positional argument follows keyword argument", output)) ||
               grepl("^SyntaxError: non-keyword arg after keyword arg", output[2])) {
        message <- "Positional argument following keyword argument."
        pa_stop(message, "syntax error:")
    } else if (grepl("^\\{|^\\[", output)) {
        args <- jsonlite::fromJSON(paste(output, collapse = ""))
        return(args)
    } else { # presumably version number request
        print_message_and_exit(output, "version requested:")
    }
}

# @param argument argument to be converted from R to Python
convert_argument <- function(argument, as_list = FALSE) {
    if (is.character(argument)) argument <- paste0('"""', argument, '"""')
    if (is.numeric(argument)) argument <- as.character(argument)
    if (is.logical(argument)) argument <- ifelse(argument, "True", "False")
    if (is.null(argument)) argument <- "None"
    if (as_list) {
        argument <- sprintf("[%s]", paste(argument, collapse = ", "))
    } else if (length(argument) > 1) {
        argument <- sprintf("(%s)", paste(argument, collapse = ", "))
    }
    argument
}

get_python_type <- function(type, proposed_arguments) {
    python_type <- switch(type,
            character = "str",
            double = "float",
            integer = "int",
            logical = "logical",
            numeric = "float",
            stop(paste(sprintf("type %s not supported,", type),
                    "supported types:",
                    "'logical', 'integer', 'double' or 'character'")))
    sprintf("type=%s", python_type)
}

should_as_list <- function(name, argument_list) {
    if (name == "default" &&
        (argument_list[["action"]] %||% "store") == "append") {
        TRUE
    } else {
        FALSE
    }
}

`%||%` <- function(x, y) if (is.null(x)) y else x # nolint

# @param mode Either "add_argument" or "ArgumentParser"
convert_..._to_arguments <- function(mode, ...) { # nolint

    argument_list <- list(...)
    argument_names <- names(argument_list)
    if (is.null(argument_names))
        argument_names <- rep_len("", length(argument_list))
    equals <- ifelse(argument_names == "", "", "=")
    proposed_arguments <- c()
    for (ii in seq_along(argument_list)) {
        name <- argument_names[ii]
        equal <- equals[ii]
        as_list <- should_as_list(name, argument_list)
        argument <- convert_argument(argument_list[[ii]], as_list)
        proposed_arguments <- append(proposed_arguments,
                                     paste0(name, equal, argument))
    }
    # Make sure types are what Python wants
    if (mode == "add_argument" && any(grepl("type=", proposed_arguments))) {
        ii <- grep("type=", proposed_arguments)
        type <- argument_list[[ii]]
        proposed_arguments[ii] <- get_python_type(type, proposed_arguments)
    }
    # Don't put quotes around formatter_class argument
    if (mode == "ArgumentParser" && any(grepl("formatter_class=", proposed_arguments))) {
        ii <- grep("formatter_class=", proposed_arguments)
        formatter_class <- argument_list[[ii]]
        proposed_arguments[ii] <- sprintf("formatter_class=%s", formatter_class)
    }
    # Set right default prog name if not specified, if possible
    # Do last to not screw up other fixes with prog insertion
    if (mode == "ArgumentParser" && needs_prog(argument_names)) {
        prog <- get_Rscript_filename()
        if (is.na(prog)) prog <- "PROGRAM"
        proposed_arguments <- c(sprintf("prog='%s'", prog), proposed_arguments)
    }
    return(paste(proposed_arguments, collapse = ", "))
}

needs_prog <- function(argument_names) {
    if (length(argument_names) == 0L) {
        TRUE
    } else if (argument_names[1L] == "") {
        FALSE
    } else if (any(argument_names == "prog")) {
        FALSE
    } else {
        TRUE
    }
}

# Manually copied over from getopt to eliminate it as a dependency
get_Rscript_filename <- function() { # nolint
    prog <- sub("--file=", "", grep("--file=", commandArgs(), value = TRUE)[1])
    if (.Platform$OS.type == "windows") {
        prog <- gsub("\\\\", "\\\\\\\\", prog)
    }
    prog
}

# Internal function to check python cmd is okay
# @param python_cmd Python cmd to use
assert_python_cmd <- function(python_cmd) {
    if (!findpython::is_python_sufficient(python_cmd, required_modules = c("argparse", "json | simplejson"))) {
        stop(paste(sprintf("python executable %s either is not installed,", python_cmd),
                "is not on the path, or does not have argparse, json modules",
                "please see INSTALL file"))
    }
}

detects_python <- function() {
    python_cmd <- try(find_python_cmd())
    !inherits(python_cmd, "try-error")
}

# Internal function to find python cmd
# @param python_cmd  Python cmd to use
find_python_cmd <- function(python_cmd = NULL) {
    if (is.null(python_cmd)) {
        python_cmd <- getOption("python_cmd")
    }
    if (is.null(python_cmd)) {
        required_modules <- c("argparse", "json | simplejson")
        did_find_python3 <- findpython::can_find_python_cmd(minimum_version = "3.0",
                                                required_modules = required_modules,
                                                silent = TRUE)
        if (did_find_python3) {
            python_cmd <- attr(did_find_python3, "python_cmd")
        } else {
            python_cmd <- findpython::find_python_cmd(required_modules = required_modules)
        }
    }
    python_cmd
}

quieter_error_handler <- function(e) {
    quit('no', status = 1, runLast = FALSE)
}

pa_stop <- function(message, r_note) {
    msg <- paste(c(r_note, message), collapse = "\n")
    cnd <- errorCondition(msg,
                          call = "argparse::parse_args_output(output)",
                          class = "argparse_parse_error")
    if (interactive()) {
        stop(cnd)
    } else {
        signalCondition(cnd)
        cat(message, sep = "\n", file = stderr())
        opt <- options(error = getOption("error",  quieter_error_handler),
                       show.error.messages = FALSE)
        on.exit(options(opt))
        stop(cnd)
    }
}

# Internal function to print message
print_message_and_exit <- function(message, r_note) {
    if (interactive()) {
        pa_stop(message, r_note)
    } else {
        cat(message, sep = "\n")
        quit(status = 0)
    }
}

---
title: "argparse Command Line Argument Parsing"
output: rmarkdown::html_vignette
vignette: >
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteIndexEntry{argparse Command Line Argument Parsing}
    %\VignetteEncoding{UTF-8}
---

argparse is a command line argument parser inspired by Python's "argparse" library.  Use this with Rscript to write "#!"-shebang scripts that accept short and long flags/options and positional arguments, generate a usage statement, and set default values for options that are not specified on the command line.

```{r echo=FALSE}
library("knitr")
rscript_executable <- paste(file.path(R.home(), "bin", "Rscript"), "--vanilla")
opts_knit$set(root.dir = system.file("exec", package = "argparse")) # to access the "Rscript files"
opts_chunk$set(comment = NA, echo = FALSE)
list_file_command <- "ls"
chmod_command <- "chmod ug+x display_file.R example.R"
path_command <- "export PATH=$PATH:`pwd`"
run_command <- function(string) suppressWarnings(cat(system(string, intern = TRUE), sep = "\n"))
```

In our working directory we have two example R scripts, named "example.R" and "display_file.R" illustrating the use of the argparse package.

**`r paste("bash$", list_file_command)`**
```{r}
run_command(sprintf("%s", list_file_command))
command <- "display_file.R example.R" # to show file
```

In order for a \*nix system to recognize a "\#!"-shebang line you need to mark the file executable with the ``chmod`` command, it also helps to add the directory containing your Rscripts to your path:

**`r paste("bash$", chmod_command)`**

**`r paste("bash$", command)`**

Here is what "example.R" contains:

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R --help" # same as system("Rscript example.R -h")
```

By default ``argparse`` will generate a help message if it encounters ``--help`` or ``-h`` on the command line.  Note how ``%(default)s`` in the example program was replaced by the actual default values in the help statement that ``argparse`` generated.

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R" # rely only on defaults
```

If you specify default values when creating your ``ArgumentParser`` then ``argparse`` will use them as expected.

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R --mean=10 --sd=10 --count=3"
```

Or you can specify your own values.

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R --quiet -c 4 --generator=\"runif\"" #  same as above but "quiet"
```

If you remember from the example program that ``--quiet`` had ``action="store_false"`` and 
``dest="verbose"``.  This means that ``--quiet`` is a switch that turns the ``verbose`` option from its default value of ``TRUE`` to ``FALSE``.  Note how the ``verbose`` and ``quiet`` options store their value in the exact same variable.

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R --silent -m 5" #  same as above but "quiet"
```

If you specify an illegal flag then \emph{argparse} will print out a usage message and an error message and quit.  

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R -c 100 -c 2 -c 1000 -c 7" #  same as above but "quiet"
```

If you specify the same option multiple times then \emph{argparse} will use the value of the last option specified. 

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "display_file.R --help"
```

``argparse`` can also parse positional arguments.  Below we give an example program ``display_file.R``, which is a program that prints out the contents of a single file (the required positional argument, not an optional argument) and which accepts the normal help option as well as an option to add line numbers to the output.

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "display_file.R --add_numbers display_file.R"
```

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "display_file.R non_existent_file.txt"
```
**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "display_file.R"
```
**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
```

---
title: "arpagrse Command Line Argument Parsing"
output: rmarkdown::html_vignette
vignette: >
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteIndexEntry{argparse Command Line Argument Parsing}
    %\VignetteEncoding{UTF-8}
---

argparse is a command line argument parser inspired by Python's "argparse" library.  Use this with Rscript to write "#!"-shebang scripts that accept short and long flags/options and positional arguments, generate a usage statement, and set default values for options that are not specified on the command line.

```{r echo=FALSE}
library("knitr")
rscript_executable <- paste(file.path(R.home(), "bin", "Rscript"), "--vanilla")
opts_knit$set(root.dir = system.file("exec", package = "argparse")) # to access the "Rscript files"
opts_chunk$set(comment = NA, echo = FALSE)
list_file_command <- "ls"
chmod_command <- "chmod ug+x display_file.R example.R"
path_command <- "export PATH=$PATH:`pwd`"
run_command <- function(string) suppressWarnings(cat(system(string, intern = TRUE), sep = "\n"))
```

In our working directory we have two example R scripts, named "example.R" and "display_file.R" illustrating the use of the argparse package.

**`r paste("bash$", list_file_command)`**
```{r}
run_command(sprintf("%s", list_file_command))
command <- "display_file.R example.R" # to show file
```

In order for a \*nix system to recognize a "\#!"-shebang line you need to mark the file executable with the ``chmod`` command, it also helps to add the directory containing your Rscripts to your path:

**`r paste("bash$", chmod_command)`**

**`r paste("bash$", command)`**

Here is what "example.R" contains:

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R --help" # same as system("Rscript example.R -h")
```

By default ``argparse`` will generate a help message if it encounters ``--help`` or ``-h`` on the command line.  Note how ``%(default)s`` in the example program was replaced by the actual default values in the help statement that ``argparse`` generated.

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R" # rely only on defaults
```

If you specify default values when creating your ``ArgumentParser`` then ``argparse`` will use them as expected.

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R --mean=10 --sd=10 --count=3"
```

Or you can specify your own values.

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R --quiet -c 4 --generator=\"runif\"" #  same as above but "quiet"
```

If you remember from the example program that ``--quiet`` had ``action="store_false"`` and 
``dest="verbose"``.  This means that ``--quiet`` is a switch that turns the ``verbose`` option from its default value of ``TRUE`` to ``FALSE``.  Note how the ``verbose`` and ``quiet`` options store their value in the exact same variable.

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R --silent -m 5" #  same as above but "quiet"
```

If you specify an illegal flag then \emph{argparse} will print out a usage message and an error message and quit.  

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "example.R -c 100 -c 2 -c 1000 -c 7" #  same as above but "quiet"
```

If you specify the same option multiple times then \emph{argparse} will use the value of the last option specified. 

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "display_file.R --help"
```

``argparse`` can also parse positional arguments.  Below we give an example program ``display_file.R``, which is a program that prints out the contents of a single file (the required positional argument, not an optional argument) and which accepts the normal help option as well as an option to add line numbers to the output.

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "display_file.R --add_numbers display_file.R"
```

**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "display_file.R non_existent_file.txt"
```
**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
command <- "display_file.R"
```
**`r paste("bash$", command)`**
```{r}
run_command(sprintf("%s %s 2>&1", rscript_executable, command))
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/argparse.R
\name{ArgumentParser}
\alias{ArgumentParser}
\title{Create a command line parser}
\usage{
ArgumentParser(..., python_cmd = NULL)
}
\arguments{
\item{...}{Arguments cleaned and passed to Pythons argparse.ArgumentParser()}

\item{python_cmd}{Python executable for \code{argparse} to use.
Must have argparse and json modules (automatically included Python 2.7 and 3.2+).
If you need Unicode argument support then you must use Python 3.0+.
Default will be to use \code{findpython} package to find suitable Python binary.}
}
\value{
\code{ArgumentParser} returns a parser object which contains
   an \code{add_argument} function to add arguments to the parser,
   a \code{parse_args} function to parse command line arguments into
   a list, a \code{print_help} and \code{print_usage} function to print
   usage information.  See code examples, package vignette,
   and corresponding python module for more information on how to use it.
}
\description{
\code{ArgumentParser} creates a parser object that acts as
a wrapper to Python's argparse module
}
\examples{

if (argparse:::detects_python()) {
  parser <- ArgumentParser(description='Process some integers')
  parser$add_argument('integers', metavar='N', type = "integer", nargs='+',
                     help='an integer for the accumulator')
  parser$add_argument('--sum', dest='accumulate', action='store_const',
                     const='sum', default='max',
                     help='sum the integers (default: find the max)')
  parser$print_help()
  # default args for ArgumentParser()$parse_args are commandArgs(TRUE)
  # which is what you'd want for an Rscript but not for interactive use
  args <- parser$parse_args(c("--sum", "1", "2", "3"))
  accumulate_fn <- get(args$accumulate)
  print(accumulate_fn(args$integers))
}
}
\references{
Python's \code{argparse} library, which this package is based on,
 is described here: \url{https://docs.python.org/3/library/argparse.html}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/argparse.R
\name{ArgumentParser}
\alias{ArgumentParser}
\title{Create a command line parser}
\usage{
ArgumentParser(..., python_cmd = NULL)
}
\arguments{
\item{...}{Arguments cleaned and passed to Pythons argparse.ArgumentParser()}

\item{python_cmd}{Python executable for \code{argparse} to use.
Must have argparse and json modules (automatically included Python 2.7 and 3.2+).
If you need Unicode argument support then you must use Python 3.0+.
Default will be to use \code{findpython} package to find suitable Python binary.}
}
\value{
\code{ArgumentParser} returns a parser object which contains
   an \code{add_argument} function to add arguments to the parser,
   a \code{parse_args} function to parse command line arguments into
   a list, a \code{print_help} and \code{print_usage} function to print
   usage information.  See code examples, package vignette,
   and corresponding python module for more information on how to use it.
}
\description{
\code{ArgumentParser} creates a parser object that acts as
a wrapper to Python's argparse module
}
\section{Acknowledgement}{

    A big thanks to Martin Diehl for a bug report.
}

\examples{

parser <- ArgumentParser(description='Process some integers')
parser$add_argument('integers', metavar='N', type = "integer", nargs='+',
                   help='an integer for the accumulator')
parser$add_argument('--sum', dest='accumulate', action='store_const',
                   const='sum', default='max',
                   help='sum the integers (default: find the max)')
parser$print_help()
# default args for ArgumentParser()$parse_args are commandArgs(TRUE)
# which is what you'd want for an Rscript but not for interactive use
args <- parser$parse_args(c("--sum", "1", "2", "3"))
accumulate_fn <- get(args$accumulate)
print(accumulate_fn(args$integers))
}
\references{
Python's \code{argparse} library, which this package is based on,
 is described here: \url{https://docs.python.org/3/library/argparse.html}
}
